cls
@title %~n0
@pushd .
@echo.
@echo ----------------------------------------------------------------------------------------
@echo Batchdatei fuer Release-Prozess fuer Maven-Multimodulprojekte im "Flat Project Layout".
@echo Folgende Schritte werden ausgefuehrt:
@echo 1. Setzen der neuen Release-Versionsnummer
@echo 2. Commit ins VCS/SCM
@echo 3. Setzen eines Tags im VCS/SCM
@echo 4. Erstellen und deployen der Ergebnis-Artefakte
@echo 5. Setzen der neuen Entwicklungs-Snapshot-Versionsnummer
@echo 6. Commit ins VCS/SCM
@echo ----------------------------------------------------------------------------------------
@echo Diese Batchdatei muss im Parent-Modul-Verzeichnis ausgefuehrt werden.
@echo Als Parameter muessen uebergeben werden:
@echo 1. Parameter: die neue Release-Versionsnummer (ohne -SNAPSHOT),     z.B.: 1.2.3
@echo 2. Parameter: die neue Entwicklungs-Versionsnummer (mit -SNAPSHOT), z.B.: 1.2.4-SNAPSHOT
@echo ----------------------------------------------------------------------------------------
@echo.
@echo.
@echo -------- Parameter ueberpruefen:
@set _startDir=%CD%
@if "%2" == "" goto _Fehler
@for /f "delims=" %%a in ('call mvn help:evaluate -Dexpression^=pom.artifactId ^| findstr /V [') do @set _mmp_afid=%%a
@set _mmp_afid_tag=^^^<artifactId^^^>%_mmp_afid%^^^</artifactId^^^>
@echo Neue Release-Versionsnummer:      %1
@echo Neue Entwicklungs-Versionsnummer: %2
@echo Startverzeichnis:                 %_startDir%
@echo MMP-artifactId:                   %_mmp_afid%
@echo MMP-Tag-Suchstring:               %_mmp_afid_tag%
@echo.
call mvn scm:validate
@if errorlevel 1 goto _Fehler
@echo.
@echo.
@echo -------- Setzen der neuen Release-Versionsnummer %1 fuer alle Module gemeinsam
@echo.
call :setzeVersion %1
@if errorlevel 1 goto _Fehler
@echo.
@echo.
@echo -------- Die Module mit Version %1 einzeln einchecken und taggen
@echo.
cd ..
call :checkinAndTag %1 tag
@if errorlevel 1 goto _Fehler
cd %_startDir%
@echo.
@echo.
@echo -------- Erstellen und deployen der Ergebnis-Artefakte mit Version %1
@echo.
call mvn clean deploy
@if errorlevel 1 goto _Fehler
@echo.
@echo.
@echo -------- Setzen der neuen Entwicklungs-Versionsnummer %2 fuer alle Module gemeinsam
@echo.
call :setzeVersion %2
@if errorlevel 1 goto _Fehler
@echo.
@echo.
@echo -------- Die Module mit Version %2 einzeln einchecken (ohne Tag)
@echo.
cd ..
call :checkinAndTag %2
@if errorlevel 1 goto _Fehler
cd %_startDir%
@echo.
@echo.
@echo -------- changelog und status
@echo.
call mvn scm:changelog | findstr /V [
@echo.
call mvn scm:status | findstr /V [
@echo.
@echo ---------------------------
@echo ++++    Erfolgreich    ++++
@echo ---------------------------
@echo 
@goto _fertig

:setzeVersion
@echo.
call mvn help:evaluate -Dexpression=pom.version | findstr /V [
call mvn versions:set -DnewVersion=%1
@if errorlevel 1 exit /B 1
call mvn versions:commit
@if errorlevel 1 exit /B 1
@echo.
call mvn help:evaluate -Dexpression=pom.version | findstr /V [
@echo.
exit /B 0

:checkinAndTag
@echo off
@echo.
FOR /F %%i in ('dir /B /A:D') DO (
  @echo.
  cd %%i
  @echo Aktuelles Unterverzeichnis: %%i
  if not exist pom.xml (
    @echo --- Info: %%i enthaelt keine 'pom.xml', deshalb keine Aktion.
  ) else (
    findstr %_mmp_afid_tag% pom.xml > nul
    if errorlevel 1 (
      @echo --- Info: Die pom.xml in %%i enthaelt nicht den String %_mmp_afid_tag%, deshalb keine Aktion.
    ) else (
      @echo.
      @echo --- Info: %%i wird eingecheckt
      call mvn scm:checkin -Dmessage="Version %1"
      @if errorlevel 1 exit /B 1
      if not "%2" == "" (
        @echo --- Info: %%i erhaelt ein Tag
        call mvn scm:tag
        @if errorlevel 1 exit /B 1
      )
    )
  )
  @echo off
  cd ..
)
exit /B 0

:_Fehler
@echo.
@echo ######################
@echo ####    FEHLER    ####
@echo ######################
@echo 
pause

:_fertig
cd %_startDir%
@popd
@title %~dp0
